///
/// \file main.cpp The main file which contains the main function
///

#include "stack.h"

///
/// \brief Main function where the execution starts
///
/// \param None
///
/// \return Int determining the success or failure of the function
///
int main()
{
	int ich; // Integer type choice of the operation user wishes to perform.
	int iError; // Error return codes from the stack operation.
	char cTemp; // temporary variable to take input from the user.
	stack s_stack; // Stack for the program.

	while(1)
	{
		cout<<"\nEnter your choice\n";
		cout<<"\n1. push\n2. pop\n3. display\n4. exit\n";
		cin>>ich;
		switch(ich)
		{
		case 1:
			//Push operation
			cout<<"Enter the charcter to push\n";
			cin>>cTemp;
			iError = s_stack.push(cTemp);
			if(iError == STACK_FULL)
				cout<<"Sorry the Stack is full\n";
			break;
		case 2:
			//Pop function
			iError = s_stack.pop(cTemp);
			if(iError == STACK_OPERATION_SUCCESS)
				cout<<"The character popped out is "<<cTemp<<endl;
			else
				cout<<"The Stack is empty\n";
			break;
		case 3:
			//displaying the stack
			s_stack.display();
			break;
		case 4:
			//Exiting the Program with sucess
			exit(0);
		}
	}
	//Exiting the main with Success
	return 0;
}
