///
/// \file stack.cpp Implementation of the functions defined in stack.h
///

#include "stack.h"

///
/// The constructor of the class stack to initialize all 
/// the member variables of the class stack
///
/// \param None
///
/// \return None
///
stack::stack()
{
	int i;
	for(i=0;i<N;i++)
		c_stk[i]=0;
	i_top=0;
}


///
/// Function to push an element into the stack.
/// 
/// \param cPush The character to be pushed
///
/// \return if any error the error code \b STACK_FULL else \b STACK_OPERATION_SUCCESS
///
int stack::push(char cPush)
{
	if(i_top==N)
		return STACK_FULL; // stack is full
	else
		c_stk[i_top++] = cPush; // Character pushed into the stack
	return STACK_OPERATION_SUCCESS;
}


///
/// Function to pop an element from the stack.
/// 
/// \param cPop The character poped
///
/// \return if any error the error code \b STACK_EMPTY else \b STACK_OPERATION_SUCCESS
///
int stack::pop(char &cPop)
{
	if(i_top==0)
		return STACK_EMPTY;
	else
		cPop = c_stk[--i_top];
	return STACK_OPERATION_SUCCESS;
}

///
/// Function to Display the content of the stack 
/// 
/// \param None
///
/// \return None
///
void stack::display(void)
{
	int i; // Loop variables
	for(i=0;i<i_top;i++)
		cout<<c_stk[i]<<"\t";
	cout<<endl;
}
