///
/// \file stack.h Definition of the Class Stack. Can be 
/// included by the compiler more than once and so its 
/// handled in the header files so that its inlcuded only once
///
#ifndef _STACK_H
#define _STACK_H

#include <iostream.h>
#include <conio.h>
#include <stdlib.h>

#define N 10 ///< Maximum limit of the Stack

#define STACK_FULL 1 ///< MAcro for Error return code when the stack is full
#define STACK_EMPTY 1 ///< MAcro for Error return code when the stack is empty
#define STACK_OPERATION_SUCCESS 0 ///< MAcro for Error return code when the stack operations are all done successfully

///
/// \brief Stack Class
///
/// \n
/// The class to do the elementary operations on stack and 
/// demostarte the functionality of the Documentation management 
/// system "Doxygen"
/// 

class stack
{
private:
	char c_stk[N];	///< Character Stack
	int i_top;		///< Top of the stack
public:
	///
	/// \brief A Constructor
	///
	stack();

	///
	/// \brief Push an element into the stack
	///
	int push(char);

	///
	/// \brief Pop out an element from the top of the stack
	///
	int pop(char &);

	///
	/// \brief Displays the content of the stack
	///
	void display(void);

	///
	/// \brief A Destructor
	///
	~stack(){}
};
#endif